diff --git a/source/src/protos.h b/source/src/protos.h
index 74c4ae496..9d003584d 100644
--- a/source/src/protos.h
+++ b/source/src/protos.h
@@ -155,6 +155,7 @@ struct keym
     ~keym() { DELETEA(name); loopi(NUMACTIONS) DELETEA(actions[i]); }
 };
 
+extern hashtable<int, keym> keyms;
 extern keym *keypressed;
 
 extern bool bindkey(keym *km, const char *action, int state = keym::ACTION_DEFAULT);
diff --git a/source/src/weapon.cpp b/source/src/weapon.cpp
index cb708577f..4ac8213a1 100644
--- a/source/src/weapon.cpp
+++ b/source/src/weapon.cpp
@@ -17,6 +17,8 @@ sgray sgr[SGRAYS*3];
 
 int burstshotssettings[NUMGUNS] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, };
 
+bool quicknade = false;
+
 void updatelastaction(playerent *d, int millis = lastmillis)
 {
     loopi(NUMGUNS) d->weapons[i]->updatetimers(millis);
@@ -36,6 +38,14 @@ void checkweaponswitch()
     {
         player1->prevweaponsel = player1->weaponsel;
         player1->weaponsel = player1->nextweaponsel;
+        if(quicknade){
+            keym *key_LMB = keyms.access(-1);
+            if(key_LMB->pressed)
+            {
+                player1->attacking = true; 
+                player1->weaponsel->attack(worldpos); 
+            }
+        }
     }
 }
 
@@ -112,8 +122,6 @@ void shiftweapon(int *s)
 }
 COMMAND(shiftweapon, "i");
 
-bool quicknade = false;
-
 void quicknadethrow(bool on)
 {
     if(player1->state != CS_ALIVE) return;
